'* Filename    :  2-                           *
'* Revision    : 5.0                                                           *
'* Controller  : ATMEGA8                                                       *
'* Compiler    : BASCOM-AVR 2.0.6.1                                            *
'* Author      : MACTEPOK                                                      *
'*******************************************************************************
$regfile = "m8def.dat"                                      ' 
$crystal = 8000000                                          ' 
'$sim
$lib "mcsbyte.lbx"                                          '  
$hwstack = 40
$swstack = 16
$framesize = 32


Config Pinc.0 = Input : Portc.0 = 1                         ' 
Config Pinc.1 = Input : Portc.1 = 1                         ' 
Config Pinc.2 = Input : Portc.2 = 1                         ' 

Config Portd = Output : Config Portb = Output               '      

Config 1wire = Portc.4                                      '     DS18B20

Load1 Alias Portb.3                                         ' 1
Load2 Alias Portb.4                                         ' 2
Vibor Alias Pinc.0                                          ' 
Up Alias Pinc.1                                             ' 
Down Alias Pinc.2                                           ' 

Config Adc = Single , Prescaler = Auto , Reference = Avcc   ' 
Dim W As Byte , Y As Byte , X As Byte , I As Byte , Z As Byte , Chislo(6) As Integer , Channel_1 As Integer , Channel_1word As Word , On1 As Word , Off1 As Word , Channel_2 As Integer , On2 As Word , Off2 As Word , Sostoyanie As Byte , Sostoyanie_2 As Byte , Copy_print As Integer , Copy_print_sec As Integer , Copy_var As Integer , _print As Integer , _print_sec As Integer , Pokazaniya As Integer , View_menu As Byte , Booton_flag As Bit , Booton_flag_2 As Bit , Count As Word , Error_flag As Bit , Error_temp_flag As Bit
Dim Razryad_1 As Byte , Razryad_2 As Byte , Temp_najatiya As Byte , Indicator As Byte
Dim Menu_punkt As Byte , Any_var As Single                  ' 
Dim Set_flag As Bit                                         '   
Dim Podskaz_flag As Bit , Podskaz_flag_sec As Bit           '      
Dim Default As Eram Byte At &H14                            ' EEPROM        
Dim Adc_ready As Bit                                        '   
Dim Chvar_1 As Single , Chvar_2 As Integer                  '    
Dim Ch1 As Integer , Ch2 As Integer,
Dim Numb As Word , Dsid1(8) As Byte , Bd1 As Byte , Bd2 As Byte , Bd(9) As Byte ,       '     DS18B20
Dim T1 As Integer , T2 As Integer , Minus_flag As Bit , Read_flag As Bit , Conv_flag As Bit , Ds_count As Byte
Const Negativ = -1


A Alias Portd.2 : B Alias Portd.6 : C Alias Portb.7 : D Alias Portb.2       ',     
E Alias Portd.0 : F Alias Portb.6 : G Alias Portd.7 : H Alias Portb.5       '
Dig1 Alias Portd.3 : Dig2 Alias Portd.4 : Dig3 Alias Portd.1       '  ,      1 
Dig1_sec Alias Portd.5 : Dig2_sec Alias Portb.0 : Dig3_sec Alias Portb.1       '  ,      2 

'A Alias Portd.5 : B Alias Portd.7 : C Alias Portd.3 : D Alias Portd.1       ',     
'E Alias Portd.0 : F Alias Portd.6 : G Alias Portd.4 : H Alias Portd.2       '
'Dig1 Alias Portb.0 : Dig2 Alias Portb.1 : Dig3 Alias Portb.2       '  ,      1 
'Dig1_sec Alias Portb.5 : Dig2_sec Alias Portb.6 : Dig3_sec Alias Portb.7       '  ,      2 


'Numb = 1wirecount()
'If Numb > 0 Then Dsid1(1) = 1wsearchfirst() Else Set Error_temp_flag

For X = 1 To 6                                              '    ,       
Chislo(x) = 11
Next
'*********** ___    (/) ___ *********************
   Readeeprom Indicator , 26
   If Vibor = 0 Then                                        '   ,  .
      For X = 1 To 200
         If X = 150 Then                                    '   
            Set Booton_flag
            Toggle Indicator.3                              '   ()  .    
            Writeeeprom Indicator , 26
            If Indicator = &B00000000 Then                  '    ,      
               Reset A : Reset B : Reset C : Reset D : Reset E : Reset F : Reset G : Reset H
               Set Dig1 : Set Dig2 : Set Dig3 : Set Dig1_sec : Set Dig2_sec : Set Dig3_sec
            End If
            If Indicator = &B00001000 Then                  '    K,      
               Set A : Set B : Set C : Set D : Set E : Set F : Set G : Set H
               Reset Dig1 : Reset Dig2 : Reset Dig3 : Reset Dig1_sec : Reset Dig2_sec : Reset Dig3_sec
            End If
            Waitms 1500
            Exit For
         End If
         If Vibor = 1 Then Exit For
         Waitms 10
      Next
   End If
'*******************************************************************************
If Default = 255 Then                                       '  ,  Default=255
   Off1 = 60                                                '  
   On1 = 40
   Off2 = 30
   On2 = 27
'   Indicator = &B00001000
   Indicator = &B00000000                                   '  . Indicator = &B00001000  
   Razryad_1 = &B10111011
   Razryad_2 = &B11101110
   Writeeeprom On1 , 0                                      '   EEPROM  ON1
   Writeeeprom Off1 , 5                                     '   EEPROM  OFF1
   Writeeeprom On2 , 10                                     '   EEPROM  ON2
   Writeeeprom Off2 , 14                                    '   EEPROM  OFF2
   Writeeeprom Razryad_1 , 16
   Writeeeprom Razryad_2 , 17
   Writeeeprom Indicator , 26
   Default = 100                                            '   100(,   255)        
End If
   Readeeprom On1 , 0                                       '   EEPROM  ON1
   Readeeprom Off1 , 5                                      '   EEPROM  OFF1
   Readeeprom On2 , 10                                      '   EEPROM  ON2
   Readeeprom Off2 , 14                                     '   EEPROM  OFF2
   Readeeprom Razryad_1 , 16
   Readeeprom Razryad_2 , 17

   Config Timer0 = Timer , Prescale = 8 : On Timer0 Pulse   '   0        
   Config Timer1 = Timer , Prescale = 1 : On Timer1 Bootons '   1        
   Enable Interrupts : Enable Timer0 : Enable Timer1        '  ,  0,    1
   Start Timer0 : Start Timer1
   Start Adc                                                '  


Do
   If X > 50 Then
      Stop Timer0 : Stop Timer1                             '     
      Ch1 = Getadc(5)                                       ' 1                                ' 
      Chvar_1 = Ch1
      Start Timer0 : Start Timer1
      Chvar_1 = 1023 - Chvar_1
      Chvar_1 = Chvar_1 / 10.23                             '          ==============
      Any_var = Chvar_1 * Any_var
      If Chvar_1 > 100 Then Chvar_1 = 100                   '  
      Channel_1 = Chvar_1                                   '     
      X = 0
   End If

   If Conv_flag = 0 Then
      Stop Timer0 : Stop Timer1
      1wreset                                               '
      1wwrite &HCC                                          '    
      1wwrite &H44                                          '  
      Start Timer0 : Start Timer1
      Set Conv_flag
      Ds_count = 0
   End If
                                               '
   If Read_flag = 1 Then
      Stop Timer0 : Stop Timer1                             '
      1wreset
      1wwrite &HCC
      1wwrite &HBE                                          '    
      Bd1 = 1wread()                                        '   
      Bd2 = 1wread()                                        '   
      Start Timer0 : Start Timer1
      If Bd2 >= 248 Then
         Bd1 = &HFF - Bd1
         Bd2 = &HFF - Bd2
         If Err = 0 Then Set Minus_flag                     '     Znak = "-"
      Else
         Reset Minus_flag                                   '     Znak = "+"
      End If
      T1 = Bd1 / 16                                         '      4  (2*2*2*2=16)
      T2 = Bd2 * 16                                         '      4  (2*2*2*2=16)
      T1 = T1 + T2
'     T1 = T1 * 10
      Chvar_2 = T1                                          '     
      If Err = 0 Then
         If Chvar_2 > 120 Then Chvar_2 = 120
         Channel_2 = Chvar_2
      End If
      Reset Read_flag
      Reset Conv_flag
   End If
   If On1 < Off1 Then                                       '  ON1 < OFF1   
      If Channel_1 <= On1 Then Sostoyanie = 1               '       ON1,    1
      If Channel_1 >= Off1 Then Sostoyanie = 0              '       OFF1,     1
   Else                                                     '  ON1 > OFF1   
      If Channel_1 >= On1 Then Sostoyanie = 1               '       ON1,    1
      If Channel_1 <= Off1 Then Sostoyanie = 0              '       OFF1,     1
   End If

   If Sostoyanie = 1 Then Set Load1 Else Reset Load1        ' 1  

   If Minus_flag = 0 Then
      If On2 < Off2 Then                                    '  ON2 < OFF2   
         If Channel_2 <= On2 Then Sostoyanie_2 = 1          '    ON2,     2
         If Channel_2 >= Off2 Then Sostoyanie_2 = 0         '    OFF2,     2
      Else                                                  '  ON2 > OFF2   
         If Channel_2 >= On2 Then Sostoyanie_2 = 1          '    ON2,     2
         If Channel_2 <= Off2 Then Sostoyanie_2 = 0         '    OFF2,     2
      End If
   End If

   If Sostoyanie_2 = 1 Then Set Load2 Else Reset Load2      ' 2  

Loop

'*******************************************************************************
' 

Pulse:
   Stop Timer0
   If View_menu <> 0 And Error_flag = 0 Then Incr Count     '        ,  ,        (~  5 )
   If Count > 7000 Then                                     '     
      Count = 0                                             ' 
      View_menu = 0                                         '      
   End If
'   H = 1                                                    '    
                                              '  0
   Select Case View_menu                                    '    ,      
      Case 0 :
         _print = Channel_1                                 '  . 1     1 
         _print_sec = Channel_2                             '  . 2     2 
      Case 1 :
         _print = On1                                       ' 1     ON1
         _print_sec = Channel_2                             ' 2     2 
      Case 2 :
         _print = Off1                                      ' 1     OFF1
         _print_sec = Channel_2                             ' 2     2 
      Case 3 :
         _print = Channel_1                                 ' 1     1 
         _print_sec = On2                                   ' 2     ON2
      Case 4 :
         _print = Channel_1                                 ' 1     1 
         _print_sec = Off2                                  ' 2     OFF2
   End Select

   If Podskaz_flag = 0 Then                                 '    1  ,    
      Copy_print = _print                                   '
      Copy_var = Copy_print                                 '
      For I = 3 To 1 Step -1                                '       3 
          Chislo(i) = Copy_print Mod 10                     '        Copy_print(123 mod 10 = 3)
          Copy_print = Copy_print / 10                      '      Copy_print (123/10=12)
      Next                                                  '   
         If Copy_var < 100 Then Chislo(1) = 11              ' 2  
'         If Copy_var < 10 Then Chislo(2) = 11               '  
   End If
   If Podskaz_flag_sec = 0 Then                             '    2  ,    
      Copy_print_sec = _print_sec                           '
      Copy_var = Copy_print_sec
      For I = 6 To 4 Step -1                                '       3 
          Chislo(i) = Copy_print_sec Mod 10                 '        _print(123 mod 10 = 3)
          Copy_print_sec = Copy_print_sec / 10              '      Copy_print_sec (123/10=12)
      Next                                                  '  
         If Copy_var < 100 Then Chislo(4) = 11              ' 2  
         If Copy_var < 10 Then Chislo(5) = 11               '  
      If Minus_flag = 1 And View_menu < 3 Then Chislo(4) = 10
   End If


   If Indicator = 0 Then                                    '     
      Reset Dig1 : Reset Dig2 : Reset Dig3 : Reset Dig1_sec : Reset Dig2_sec : Reset Dig3_sec       '    
   Else
      Set Dig1 : Set Dig2 : Set Dig3 : Set Dig1_sec : Set Dig2_sec : Set Dig3_sec       '   K
   End If

   Incr W : If W > 6 Then W = 1                             '     
   Y = 0
   Gosub Look : A = Z                                       '    Look,        
   Gosub Look : B = Z
   Gosub Look : C = Z
   Gosub Look : D = Z
   Gosub Look : E = Z
   Gosub Look : F = Z
   Gosub Look : G = Z

   Select Case W                                            '  ()   (w).        ()
      Case 1 :
         If Indicator = 0 Then
            Set Dig3
            If Podskaz_flag = 0 Then H = Razryad_1.3 Else H = 1
         Else
            Reset Dig3
            If Podskaz_flag = 0 Then
               H = Razryad_1.3
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 2 :
         If Indicator = 0 Then
            Set Dig2
            If Podskaz_flag = 0 Then H = Razryad_1.2 Else H = 1
         Else
            Reset Dig2
            If Podskaz_flag = 0 Then
               H = Razryad_1.2
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 3 :
         If Indicator = 0 Then
            Set Dig1
            If Podskaz_flag = 0 Then H = Razryad_1.1 Else H = 1
         Else
            Reset Dig1
            If Podskaz_flag = 0 Then
               H = Razryad_1.1
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 4 :
         If Indicator = 0 Then
            Set Dig3_sec
            If Podskaz_flag_sec = 0 Then H = Razryad_2.3 Else H = 1
         Else
            Reset Dig3_sec
            If Podskaz_flag_sec = 0 Then
               H = Razryad_2.3
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 5 :
         If Indicator = 0 Then
            Set Dig2_sec
            If Podskaz_flag_sec = 0 Then H = Razryad_2.2 Else H = 1
         Else
            Reset Dig2_sec
            If Podskaz_flag_sec = 0 Then
               H = Razryad_2.2
               Toggle H
            Else
               H = 0
            End If
         End If
      Case 6 :
         If Indicator = 0 Then
            Set Dig1_sec
            If Podskaz_flag_sec = 0 Then H = Razryad_2.1 Else H = 1
         Else
            Reset Dig1_sec
            If Podskaz_flag_sec = 0 Then
               H = Razryad_2.1
               Toggle H
            Else
               H = 0
            End If
         End If
   End Select
'

   Start Timer0
Return
'
Look:                                                       '        ,    
   Z = Chislo(w) * 7 : Z = Y + Z                            '       DATA. W -      1..2..3, Y    (A=0 B=1 C=2...G=7)
   If Indicator = 0 Then
      Z = Lookup(z , Cifri_oa)                              '           -OA
   Else
      Z = Lookup(z , Cifri_ok)                              '-OK
   End If
   Incr Y                                                   'Y    (A=0 B=1 C=2...). Chislo(w) * 7 -      Data.Z = Y + Z -      .
Return
'
Cifri_oa:
'             |Chislo(i)|  |
Data 0 , 0 , 0 , 0 , 0 , 0 , 1                              '0
Data 1 , 0 , 0 , 1 , 1 , 1 , 1                              '1
Data 0 , 0 , 1 , 0 , 0 , 1 , 0                              '2
Data 0 , 0 , 0 , 0 , 1 , 1 , 0                              '3
Data 1 , 0 , 0 , 1 , 1 , 0 , 0                              '4
Data 0 , 1 , 0 , 0 , 1 , 0 , 0                              '5
Data 0 , 1 , 0 , 0 , 0 , 0 , 0                              '6
Data 0 , 0 , 0 , 1 , 1 , 1 , 1                              '7
Data 0 , 0 , 0 , 0 , 0 , 0 , 0                              '8
Data 0 , 0 , 0 , 0 , 1 , 0 , 0                              '9
Data 1 , 1 , 1 , 1 , 1 , 1 , 0                              '10           "-"
Data 1 , 1 , 1 , 1 , 1 , 1 , 1                              '11           ""
Data 1 , 1 , 1 , 0 , 0 , 0 , 1                              '12           "L"
Data 1 , 1 , 0 , 1 , 0 , 1 , 0                              '13           "n"
Data 0 , 1 , 1 , 1 , 0 , 0 , 0                              '14           "F"
Data 0 , 1 , 1 , 0 , 0 , 0 , 0                              '15           "E"
Data 1 , 1 , 1 , 1 , 0 , 1 , 0                              '16           "r"

'*******************************************************************************
Cifri_ok:
'             |Chislo(i)|  |
Data 1 , 1 , 1 , 1 , 1 , 1 , 0                              '0
Data 0 , 1 , 1 , 0 , 0 , 0 , 0                              '1
Data 1 , 1 , 0 , 1 , 1 , 0 , 1                              '2
Data 1 , 1 , 1 , 1 , 0 , 0 , 1                              '3
Data 0 , 1 , 1 , 0 , 0 , 1 , 1                              '4
Data 1 , 0 , 1 , 1 , 0 , 1 , 1                              '5
Data 1 , 0 , 1 , 1 , 1 , 1 , 1                              '6
Data 1 , 1 , 1 , 0 , 0 , 0 , 0                              '7
Data 1 , 1 , 1 , 1 , 1 , 1 , 1                              '8
Data 1 , 1 , 1 , 1 , 0 , 1 , 1                              '9
Data 0 , 0 , 0 , 0 , 0 , 0 , 1                              '10           "-"
Data 0 , 0 , 0 , 0 , 0 , 0 , 0                              '11           "" 
Data 0 , 0 , 0 , 1 , 1 , 1 , 0                              '12           "L"
Data 0 , 0 , 1 , 0 , 1 , 0 , 1                              '13           "n"
Data 1 , 0 , 0 , 0 , 1 , 1 , 1                              '14           "F"
Data 1 , 0 , 0 , 1 , 1 , 1 , 1                              '15           "E"
Data 0 , 0 , 0 , 0 , 1 , 0 , 1                              '16           "r"

'*******************************************************************************
'
'*******************************************************************************
'  
Bootons:
   Incr X
   If Conv_flag = 1 Then Incr Ds_count
   If Ds_count > 80 Then
      Set Read_flag
   End If
   Stop Timer1
      If Vibor = 0 And Booton_flag = 0 And Up = 1 And Down = 1 Then Gosub Set_mode       '   
      If Set_flag = 1 And Vibor = 1 Then                    '         
         If Up = 0 Then Gosub Up_const
         If Down = 0 Then Gosub Down_const
      End If
      If Vibor = 0 And Up = 0 And View_menu = 0 And Booton_flag_2 = 0 Then Gosub Set_h_led1
      If Vibor = 0 And Down = 0 And View_menu = 0 And Booton_flag_2 = 0 Then Gosub Set_h_led2

      If Vibor = 1 And Up = 1 And Down = 1 Then Reset Booton_flag       '   
      If Vibor = 1 Then Reset Booton_flag_2
   Start Timer1 : Start Timer0
Return
'*******************************************************************************
'
'
Set_mode:
   Enable Interrupts : Enable Timer0 : Start Timer0

   Set Set_flag                                             '      (  )
   Set Booton_flag                                          '     (  ,      )
   Count = 0                                                '     
   If On1 = Off1 Or On2 = Off2 Then Gosub Errors            '  .     
   Incr View_menu                                           '   
   If View_menu > 4 Then View_menu = 0                      '  4  , 0 -  

      Select Case View_menu                                 '   
       Case 0 :                                             ' ---
           Set Podskaz_flag
           Set Podskaz_flag_sec
           Chislo(1) = 10
           Chislo(2) = 10
           Chislo(3) = 10
           Chislo(4) = 10
           Chislo(5) = 10
           Chislo(6) = 10
           Reset Set_flag                                   '
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom Off2 , 14                            '   OFF2  EEPROM

       Case 1 :                                             ' On1
           Set Podskaz_flag                                 '    ()  1 
           Chislo(3) = 1
           Chislo(2) = 13
           Chislo(1) = 0
           Waitms 500

       Case 2 :                                             ' OF1
           Set Podskaz_flag                                 '    ()  1 
           Chislo(3) = 1
           Chislo(2) = 14
           Chislo(1) = 0
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom On1 , 0                              '   ON1  EEPROM

       Case 3 :                                             ' On2
           Set Podskaz_flag_sec                             '    ()  2 
           Chislo(6) = 2
           Chislo(5) = 13
           Chislo(4) = 0
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom Off1 , 5                             '   OFF1  EEPROM

       Case 4 :                                             ' OFF2
           Set Podskaz_flag_sec                             '    ()  2 
           Chislo(6) = 2
           Chislo(5) = 14
           Chislo(4) = 0
           Waitms 500
           Stop Timer1 : Stop Timer0
           Writeeeprom On2 , 10                             '   ON2  EEPROM

           End Select

   Reset Podskaz_flag
   Reset Podskaz_flag_sec
Return
'
Errors:
   Set Error_flag                                           '   
   If On1 = Off1 Then
      Set Podskaz_flag
      Chislo(1) = 15
      Chislo(2) = 16                                        '  Err    1 
      Chislo(3) = 16
      Waitms 500
      Chislo(1) = 11
      Chislo(2) = 11
      Chislo(3) = 11
      Waitms 500
      Chislo(1) = 15
      Chislo(2) = 16
      Chislo(3) = 16
      Waitms 500
      Chislo(1) = 11
      Chislo(2) = 11
      Chislo(3) = 11
      Waitms 500
   End If
   If On2 = Off2 Then
      Set Podskaz_flag_sec
      Chislo(4) = 15
      Chislo(5) = 16                                        '  Err    2 
      Chislo(6) = 16
      Waitms 500
      Chislo(4) = 11
      Chislo(5) = 11
      Chislo(6) = 11
      Waitms 500
      Chislo(4) = 15
      Chislo(5) = 16
      Chislo(6) = 16
      Waitms 500
      Chislo(4) = 11
      Chislo(5) = 11
      Chislo(6) = 11
      Waitms 500
   End If
   Select Case View_menu                                    '   ,       
      Case 0 :                                              '   EEPROM  
      Case 1 :
         Readeeprom On1 , 0
      Case 2 :
         Readeeprom Off1 , 5
      Case 3 :
          Readeeprom On2 , 10
      Case 4 :
         Readeeprom Off2 , 14
   End Select
   Decr View_menu                                           '      ( )
   Count = 0 : Reset Error_flag
Return
'
Up_const:
   Enable Interrupts : Enable Timer0 : Start Timer0
   Count = 0
   Select Case View_menu
      Case 1 :
            If On1 < 100 Then Incr On1                      '
      Case 2 :                                              '
            If Off1 < 100 Then Incr Off1
      Case 3 :                                              '
            If On2 < 120 Then Incr On2                      '
      Case 4 :                                              '
            If Off2 < 120 Then Incr Off2
   End Select
   Waitms 30
Return
'
'
Down_const:
   Enable Interrupts : Enable Timer0 : Start Timer0
   Count = 0
   Select Case View_menu
      Case 1 :
            If On1 > 0 Then Decr On1                        '        
      Case 2 :
            If Off1 > 0 Then Decr Off1
      Case 3 :
            If On2 > 0 Then Decr On2
      Case 4 :
            If Off2 > 0 Then Decr Off2
   End Select
   Waitms 30
Return
'
'
Set_h_led1:
   Set Booton_flag_2
   Rotate Razryad_1 , Left
   Stop Timer1 : Stop Timer0
   Writeeeprom Razryad_1 , 16
Return
'
'
Set_h_led2:
   Set Booton_flag_2
   Rotate Razryad_2 , Left
   Stop Timer1 : Stop Timer0
   Writeeeprom Razryad_2 , 17
Return